class Proxy:
    def __init__(
            self,
            host: str | None = None,
            port: str | None = None,
            username: str | None = None,
            password: str | None = None,
            information: list[str] | None = None
    ):
        if information is None:
            self.host = host
            self.port = port
            self.username = username
            self.password = password
        else:
            self.host, self.port, self.username, self.password = information

    def __call__(self, *types: str):
        if len(types) == 0:
            types = ('http', 'https')
        return {
            f'{proxy_type}':
                f'{proxy_type}://{self.username}:{self.password}@{self.host}:{self.port}' for proxy_type in types
        }

    def dictionary(self):
        return {
            'server': f"{self.host}:{self.port}",
            'username': self.username,
            'password': self.password,
        }
